#include "test_statistics.hpp"
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctime>
std::string get_test_results_directory()
{
    std::ostringstream ss;
    ss << "test/";
    auto t = std::time(nullptr);
    auto tm = *std::localtime(&t);
    ss << std::put_time(&tm,"%d-%m-%Y") << "-";
    struct stat s;
    for(int i = 1;;++i)
    {
        std::string number_to_string = std::to_string(i);
        std::string dir = ss.str() + number_to_string;
        if(stat(dir.c_str(),&s) == -1)
            return dir;

    }
}
std::string get_test_results_file_name()
{
    char hostname[100];
    if(gethostname(hostname,100) == 0)
    {
        return std::string(hostname) + ".stats";
    }else return nullptr;
}
bool save_stats(std::string dir, int win_v1,int win_v2, int draws)
{
    struct stat s;
    if(stat("test",&s) == -1)
    {
        mkdir("test",0700);
    }
    std::string filename(get_test_results_file_name());
    if(stat(dir.c_str(),&s) == -1)
    {
        mkdir(dir.c_str(),0700);
    }
    std::string relative_path(dir+"/" +filename);
    FILE* f = fopen(relative_path.c_str(),"w");
    if(f == nullptr)
    {
        return false;
    }
    fprintf(f,"%d %d %d",win_v1,win_v2,draws);
    fclose(f);
    return true;
}
