/**
 * Artificial Intelligence for the Penguin Game project.
 * https://gitlab.insa-rennes.fr/francesco-bariatti/pingouins
 * This AI, with the exception of game/penguin.hpp and game/penguin.cpp has been written by Pascal Garcia
 * Copyright (C) 2016 Pascal Garcia
 * It is licensed under the MIT license: you can find a copy in the file LICENSE.txt shipped with the whole project.
 * ------------------------------------------------------------------------------------------------------------------------
 * game/penguin.hpp and game/penguin.cpp have been written by Francesco Bariatti, Adrien Gasté, Mikael Le, Romain Lebouc.
 * Copyright (C) 2016 Francesco Bariatti < francesco.bariatti@insa-rennes.fr >, Adrien Gasté < adrien.gaste@insa-rennes.fr >, Mikael Le < mikael.le@insa-rennes.fr >, Romain Lebouc < romain.lebouc@insa-rennes.fr >
 * They are also licensed under the MIT license: you can find a copy in the file LICENSE.txt shipped with the whole project.
 * -------------------------------------------------------------------------------------------------------------------------------------
 * This program uses the jsoncpp library.
 * You can find a copy of the library at https://github.com/open-source-parsers/jsoncpp
 * The library is licensed under MIT license.
 * Copyright (c) 2007-2010 Baptiste Lepilleur
 */


#include "penguin.hpp"
#include "test_two_players_game.hpp"
#include "test_fast_log.hpp"
#include "test_allocator.hpp"
#include "test_mcts_two_players.hpp"
#include "test_bits.hpp"
#include "learning.hpp"
#include "penguin_heuristic.hpp"
#include "config.hpp"
#include <omp.h>

using namespace std;

int main(int argc, char *argv[])
{
	// mcts::test_allocator(10, 2);
	// omp_set_num_threads(8);
	game::config& c = game::config::get_config();

    const mcts::penguin_heuristic& h1 = *(c.get_heuristic(1));
    const mcts::penguin_heuristic& h2 = *(c.get_heuristic(2));
    
    mcts::run_test_mcts_two_players(game::penguin(),h1,h2);

	return 0;
}
